import React from 'react';
import Button from 'reactstrap/lib/Button';

import { SendAmount } from './send-amount';
import { InputWithIcon } from '../../form/input-with-icon/input-with-icon';

const props = {
  rate: '0.2',
  maxAmount: '1200',
  ethValue: '2',
  scrValue: '233',
  scrAddress: 'sdfs12kjnDFA',
  onEthChange: jest.fn(),
  onScrChange: jest.fn(),
  onDoneClick: jest.fn(),
};
let wrapper;

jest.useFakeTimers();

describe('<CalcAmount />', () => {
  wrapper = shallow(<SendAmount {...props} />);

  test('should match snapshot', () => {
    expect(wrapper).toMatchSnapshot();
  });

  test('click on `done button` should trigger `onDoneClick` prop', () => {
    wrapper.find(Button).last().simulate('click');
    expect(props.onDoneClick).toHaveBeenCalledTimes(1);
  });

  test('change value in the fist `InputWithIcon` component should trigger `onEthChange` prop', () => {
    wrapper.find(InputWithIcon).first().simulate('change', { target: { value: '7' } });
    expect(props.onEthChange).toHaveBeenCalledWith({ target: { value: '7' } });
  });

  test('change value in the last `InputWithIcon` component should trigger `onScrChange` prop', () => {
    wrapper.find(InputWithIcon).last().simulate('change', { target: { value: '3' } });
    expect(props.onScrChange).toHaveBeenCalledWith({ target: { value: '3' } });
  });
});
